<template>
    <section>
        <h2>Add Ad Unit</h2>
        <span class="text-small text-muted">For [Content Name]</span>

        <form>
            <div class="form-group">
                <label for="nameInput">Name</label>
                <input type="text" v-model="name" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.name}]" id="nameInput" placeholder="Eg: Bottom Banner">

                <template v-if="validationError && validationError.name">
                            <span class="invalid-feedback">
                                <strong>{{ validationError.name[0] }}</strong>
                            </span>
                </template>
            </div>

            <!--<div class="form-group">
                <label for="categorySelect">Content Category</label>
                <select id="categorySelect" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.type}]" v-model="type">
                    <option value="text">Text</option>
                    <option value="image">Image</option>
                    <option value="both">Both</option>
                </select>

                <template v-if="validationError && validationError.type">
                            <span class="invalid-feedback">
                                <strong>{{ validationError.type[0] }}</strong>
                            </span>
                </template>
            </div>-->

            <label style="margin-bottom: 0.5rem;">Size</label>

            <div class="list-group">
                <a href="#" v-bind:class="['list-group-item', 'list-group-item-action', 'flex-column', 'align-items-start', {'active' : isSelectedAdSize(adSize.size)}]"  v-on:click.prevent="selectAdSize(adSize.size)" v-for="adSize in adSizes">
                    <div class="d-flex w-100 justify-content-between">
                        <h5 class="mb-1">{{ adSize.name }} ({{adSize.size}})</h5>
                        <small>{{ adSize.type }}</small>
                    </div>
                    <small>{{ adSize.platform}}</small>
                </a>
            </div>

            <template v-if="validationError && validationError.size">
                <small class="text-danger font-weight-bold">{{ validationError.size[0] }}</small><br>
            </template>

            <div class="alert alert-success" v-if="success">
                {{ success.message }}
                <button type="button" class="close" v-on:click.prevent="success = '';" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>

            <div class="alert alert-danger" v-if="fail">
                {{ fail.message }}
                <button type="button" class="close" v-on:click.prevent="fail = '';" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>

            <br>

            <button type="submit" class="btn btn-primary" v-if="loading" disabled><i class="fas fa-spinner fa-spin"></i> Add</button>
            <button type="submit" class="btn btn-primary" v-else v-on:click.prevent="addAdUnit">Add</button>

        </form>


    </section>
</template>

<script>
    export default {
        data: function () {
            return {
                // Form inputs
                name: '',
                type: '',

                // Content ID
                contentId: this.$route.params.content,

                // Ad Size Options
                adSizes: '',

                // Selected Ad Size
                adSize: '',

                // Loading flag
                loading: false,

                // Validation Error object
                validationError: '',

                // Success Flag
                success: '',

                // Fail flag
                fail: '',

            }
        },
        methods: {
            addAdUnit: function () {
                // Show the loading
                this.loading = true;

                // Clear previous flags
                this.fail = '';
                this.validationError = '';

                // Make the request to the server
                axios.post('/api/publisher/content/' + this.contentId + '/adunit/new', { 'name': this.name, 'size': this.adSize})
                    .then(response => {
                        // On Success
                        this.success = {
                            message: 'Ad Unit Added'
                        };

                        // Clear previous input fields
                        this.name = '';
                        this.type = '';

                        console.log('New Ad Unit Added');
                    })
                    .catch(error => {
                        if (error.response) {
                            // The request was made and the server responded with a status code
                            // that falls out of the range of 2xx
                            console.log(error.response.status);

                            // Handle validation errors
                            if (error.response.status === 422) {
                                this.validationError = error.response.data.errors;
                            } else if(error.response.status === 403) {
                                this.fail = {
                                    message: 'You are not allowed to add a new ad unit to this content.'
                                };
                            } else {
                                this.fail = {
                                    message: error.response.stats + ' Something went wrong.'
                                };
                            }

                        } else if (error.request) {
                            // The request was made, but no response was received
                            console.log(error.request);

                            this.fail = {
                                message: 'Check your connection and try again.'
                            };

                        } else {
                            // Something happened in setting up the request that triggered an error
                            console.log('Error', error.message);

                            this.fail = {
                                message: 'Something went wrong. Please Try Again'
                            };
                        }
                    })
                    .then(e => {
                        // Hide the loading
                        this.loading = false;
                    });
            },
            setAdSizes: function () {
                this.adSizes = [
                    {
                        size: '320X50',
                        name: 'Mobile Banner',
                        type: 'Horizontal',
                        platform: 'android, web'
                    },
                    {
                        size: '320X100',
                        name: 'Large Mobile Banner',
                        type: 'Horizontal',
                        platform: 'android, web'
                    },
                    {
                        size: '728X90',
                        name: 'Leader Board',
                        type: 'Horizontal',
                        platform: 'android, web'
                    },
                    {
                        size: '336X280',
                        name: 'Large Rectangle',
                        type: 'Rectangular',
                        platform: 'android, web'
                    },
                    {
                        size: '300X250',
                        name: 'Medium Rectangle',
                        type: 'Rectangular',
                        platform: 'android, web'
                    },
                    {
                        size: '300X600',
                        name: 'Sky Scraper',
                        type: 'Vertical',
                        platform: 'web'
                    },

                ]
            },
            selectAdSize: function (adSize) {
                this.adSize = adSize;
            },
            isSelectedAdSize: function (adSize) {
                return this.adSize === adSize;
            }
        },
        watch: {
            '$route.params.content': function(content) {
                this.contentId = content;
            }
        },
        mounted() {
            // Set the ad sizes
            this.setAdSizes();

            console.log('Publisher - Add Ad Unit mounted.')
        }
    }
</script>
